Package org.apache.commons.math3.ode.nonstiff

# Class EmbeddedRungeKuttaIntegrator

java.lang.Object
org.apache.commons.math3.ode.AbstractIntegrator
org.apache.commons.math3.ode.nonstiff.AdaptiveStepsizeIntegrator
org.apache.commons.math3.ode.nonstiff.EmbeddedRungeKuttaIntegrator

All Implemented Interfaces:
  `FirstOrderIntegrator`, `ODEIntegrator`

Direct Known Subclasses:
  `DormandPrince54Integrator`, `DormandPrince853Integrator`, `HighamHall54Integrator`

public abstract class EmbeddedRungeKuttaIntegrator extends AdaptiveStepsizeIntegrator
This class implements the common part of all embedded Runge-Kutta integrators for Ordinary Differential Equations.

These methods are embedded explicit Runge-Kutta methods with two sets of coefficients allowing to estimate the error, their Butcher arrays are as follows :

        0  |
       c2  | a21
       c3  | a31  a32
       ... |        ...
       cs  | as1  as2  ...  ass-1
           |--------------------------
           |  b1   b2  ...   bs-1  bs
           |  b'1  b'2 ...   b's-1 b's

In fact, we rather use the array defined by ej = bj - b'j to compute directly the error rather than computing two estimates and then comparing them.

Some methods are qualified as fsal (first same as last) methods. This means the last evaluation of the derivatives in one step is the same as the first in the next step. Then, this evaluation can be reused from one step to the next one and the cost of such a method is really s-1 evaluations despite the method still has s stages. This behaviour is true only for successful steps, if the step is rejected after the error estimation phase, no evaluation is saved. For an fsal method, we have cs = 1 and asi = bi for all i.

Since:
  1.2

## Field Summary

### Fields inherited from class org.apache.commons.math3.ode.nonstiff.AdaptiveStepsizeIntegrator

`mainSetDimension, scalAbsoluteTolerance, scalRelativeTolerance, vecAbsoluteTolerance, vecRelativeTolerance`

### Fields inherited from class org.apache.commons.math3.ode.AbstractIntegrator

`isLastStep, resetOccurred, stepHandlers, stepSize, stepStart`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`EmbeddedRungeKuttaIntegrator(String name, boolean fsal, double[] c, double[][] a, double[] b, org.apache.commons.math3.ode.nonstiff.RungeKuttaStepInterpolator prototype, double minStep, double maxStep, double[] vecAbsoluteTolerance, double[] vecRelativeTolerance)`
Build a Runge-Kutta integrator with the given Butcher array.
`protected`
`EmbeddedRungeKuttaIntegrator(String name, boolean fsal, double[] c, double[][] a, double[] b, org.apache.commons.math3.ode.nonstiff.RungeKuttaStepInterpolator prototype, double minStep, double maxStep, double scalAbsoluteTolerance, double scalRelativeTolerance)`
Build a Runge-Kutta integrator with the given Butcher array.

## Method Summary

Modifier and Type
Method
Description
`protected abstract double`
`estimateError(double[][] yDotK, double[] y0, double[] y1, double h)`
Compute the error ratio.
`double`
`getMaxGrowth()`
Get the maximal growth factor for stepsize control.
`double`
`getMinReduction()`
Get the minimal reduction factor for stepsize control.
`abstract int`
`getOrder()`
Get the order of the method.
`double`
`getSafety()`
Get the safety factor for stepsize control.
`void`
`integrate(ExpandableStatefulODE equations, double t)`
Integrate a set of differential equations up to the given time.
`void`
`setMaxGrowth(double maxGrowth)`
Set the maximal growth factor for stepsize control.
`void`
`setMinReduction(double minReduction)`
Set the minimal reduction factor for stepsize control.
`void`
`setSafety(double safety)`
Set the safety factor for stepsize control.

### Methods inherited from class org.apache.commons.math3.ode.nonstiff.AdaptiveStepsizeIntegrator

`filterStep, getCurrentStepStart, getMaxStep, getMinStep, initializeStep, resetInternalState, sanityChecks, setInitialStepSize, setStepSizeControl, setStepSizeControl`

### Methods inherited from class org.apache.commons.math3.ode.AbstractIntegrator

`acceptStep, addEventHandler, addEventHandler, addStepHandler, clearEventHandlers, clearStepHandlers, computeDerivatives, getCounter, getCurrentSignedStepsize, getEvaluations, getEvaluationsCounter, getEventHandlers, getExpandable, getMaxEvaluations, getName, getStepHandlers, initIntegration, integrate, setEquations, setMaxEvaluations, setStateInitialized`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### EmbeddedRungeKuttaIntegrator

protected EmbeddedRungeKuttaIntegrator(String name, boolean fsal, double[] c, double[][] a, double[] b, org.apache.commons.math3.ode.nonstiff.RungeKuttaStepInterpolator prototype, double minStep, double maxStep, double scalAbsoluteTolerance, double scalRelativeTolerance)
Build a Runge-Kutta integrator with the given Butcher array.

Parameters:
  `name` - name of the method
  `fsal` - indicate that the method is an fsal
  `c` - time steps from Butcher array (without the first zero)
  `a` - internal weights from Butcher array (without the first empty row)
  `b` - propagation weights for the high order method from Butcher array
  `prototype` - prototype of the step interpolator to use
  `minStep` - minimal step (sign is irrelevant, regardless of integration direction, forward or backward), the last step can be smaller than this
  `maxStep` - maximal step (sign is irrelevant, regardless of integration direction, forward or backward), the last step can be smaller than this
  `scalAbsoluteTolerance` - allowed absolute error
  `scalRelativeTolerance` - allowed relative error

### EmbeddedRungeKuttaIntegrator

protected EmbeddedRungeKuttaIntegrator(String name, boolean fsal, double[] c, double[][] a, double[] b, org.apache.commons.math3.ode.nonstiff.RungeKuttaStepInterpolator prototype, double minStep, double maxStep, double[] vecAbsoluteTolerance, double[] vecRelativeTolerance)
Build a Runge-Kutta integrator with the given Butcher array.

Parameters:
  `name` - name of the method
  `fsal` - indicate that the method is an fsal
  `c` - time steps from Butcher array (without the first zero)
  `a` - internal weights from Butcher array (without the first empty row)
  `b` - propagation weights for the high order method from Butcher array
  `prototype` - prototype of the step interpolator to use
  `minStep` - minimal step (must be positive even for backward integration), the last step can be smaller than this
  `maxStep` - maximal step (must be positive even for backward integration)
  `vecAbsoluteTolerance` - allowed absolute error
  `vecRelativeTolerance` - allowed relative error

## Method Details

### getOrder

public abstract int getOrder()
Get the order of the method.

Returns:
  order of the method

### getSafety

public double getSafety()
Get the safety factor for stepsize control.

Returns:
  safety factor

### setSafety

public void setSafety(double safety)
Set the safety factor for stepsize control.

Parameters:
  `safety` - safety factor

### integrate

public void integrate(ExpandableStatefulODE equations, double t) throws NumberIsTooSmallException, DimensionMismatchException, MaxCountExceededException, NoBracketingException
Integrate a set of differential equations up to the given time.

This method solves an Initial Value Problem (IVP).

The set of differential equations is composed of a main set, which can be extended by some sets of secondary equations. The set of equations must be already set up with initial time and partial states. At integration completion, the final time and partial states will be available in the same object.

Since this method stores some internal state variables made available in its public interface during integration (`AbstractIntegrator.getCurrentSignedStepsize()`), it is not thread-safe.

Specified by:
  `integrate` in class `AdaptiveStepsizeIntegrator`
Parameters:
  `equations` - complete set of differential equations to integrate
  `t` - target time for the integration (can be set to a value smaller than `t0` for backward integration)
Throws:
  `NumberIsTooSmallException` - if integration step is too small
  `DimensionMismatchException` - if the dimension of the complete state does not match the complete equations sets dimension
  `MaxCountExceededException` - if the number of functions evaluations is exceeded
  `NoBracketingException` - if the location of an event cannot be bracketed

### getMinReduction

public double getMinReduction()
Get the minimal reduction factor for stepsize control.

Returns:
  minimal reduction factor

### setMinReduction

public void setMinReduction(double minReduction)
Set the minimal reduction factor for stepsize control.

Parameters:
  `minReduction` - minimal reduction factor

### getMaxGrowth

public double getMaxGrowth()
Get the maximal growth factor for stepsize control.

Returns:
  maximal growth factor

### setMaxGrowth

public void setMaxGrowth(double maxGrowth)
Set the maximal growth factor for stepsize control.

Parameters:
  `maxGrowth` - maximal growth factor

### estimateError

protected abstract double estimateError(double[][] yDotK, double[] y0, double[] y1, double h)
Compute the error ratio.

Parameters:
  `yDotK` - derivatives computed during the first stages
  `y0` - estimate of the step at the start of the step
  `y1` - estimate of the step at the end of the step
  `h` - current step
Returns:
  error ratio, greater than 1 if step should be rejected